if initialized == nil then initialized = false; end

if not initialized then
    wand_cache = {}
    SpellSprites = {}
    initialized = true
    dofile_once("mods/Advanced Inventory/files/scripts/item_list.lua")
    dofile_once( "data/scripts/lib/utilities.lua" )
    local gui = gui or GuiCreate();
    local gui_id = 6969
    GuiStartFrame( gui );
    local screen_width, screen_height = GuiGetScreenDimensions(gui)
    local show_bank = false
    local bankfilter = ""
    local filteredItems = {}
    local bank_offset = 0
    local last_inven_is_open = false

    local _wand_tooltip = {
        "$inventory_shuffle",
        "$inventory_actionspercast",
        "$inventory_castdelay",
        "$inventory_rechargetime",
        "$inventory_manamax",
        "$inventory_manachargespeed",
        "$inventory_capacity",
        "$inventory_spread"
    }

    function PopulateSpellList()
        dofile_once("data/scripts/gun/gun_actions.lua")
        for _, spell in ipairs(actions) do
            SpellSprites[spell.id] = {
                name = GameTextGetTranslatedOrNot(spell.name),
                sprite = spell.sprite
            }
        end
    end
    PopulateSpellList()
    local function reset_id()
        gui_id = 6969
    end
    
    local function next_id()
        local id = gui_id
        gui_id = gui_id + 1
        return id
    end

    local function previous_data( gui )
        local left_click,right_click,hover,x,y,width,height,draw_x,draw_y,draw_width,draw_height = GuiGetPreviousWidgetInfo( gui );
        if left_click == 1 then left_click = true; elseif left_click == 0 then left_click = false; end
        if right_click == 1 then right_click = true; elseif right_click == 0 then right_click = false; end
        if hover == 1 then hover = true; elseif hover == 0 then hover = false; end
        return left_click,right_click,hover,x,y,width,height,draw_x,draw_y,draw_width,draw_height;
    end

    local function wand_tooltip(wand)
        local ret = {
            wand.shuffle_deck_when_empty and "Yes" or "No",
            tostring(wand.actions_per_round),
            string.format("%.2f",wand.fire_rate_wait / 60),
            string.format("%.2f",wand.reload_time / 60),
            string.format("%.0f",wand.mana_max),
            string.format("%.0f",wand.mana_charge_speed),
            tostring(wand.deck_capacity),
            string.format("%.2f DEG",wand.spread_degrees)
        }
        return ret
    end

    local function flask_info(flask, chest)
        local materials = ""
        local d = 10
        if (chest) then d = 15 end
        for i, inv in ipairs(flask) do
            local translated_text = ""
            translated_text = GameTextGetTranslatedOrNot(CellFactory_GetUIName(inv.id))
            materials = materials .. string.format("%s%s %s\n",
            math.ceil(inv.amount / d),
            "%",
            translated_text)
        end
        return materials
    end

    local function change_bank_offset(num, pages)
        local offset = bank_offset + num
        if (offset >= 0 and offset <= pages) then
            bank_offset = offset
        end
    end

    local function get_wand_sprite(filename)
        if (wand_cache[filename] ~= nil) then return wand_cache[filename] end
        local wand = {}
        wand.sprite = filename
        if (filename:sub(-#".xml") == ".xml") then
            wand.sprite = _ModTextFileGetContent(filename):match([[filename="([^"]+)]])
        end

        local w, h = GuiGetImageDimensions(gui, wand.sprite, 1)
        local ox = ((w - 20) / 2) * -1
        local oy = ((h - 20) / 2) * -1
        wand.ox = ox
        wand.oy = oy
        wand_cache[filename] = wand
        return wand_cache[filename]
    end

    local function draw_item_sprite(item, x,y)
        GuiZSetForNextWidget(gui, 8)
        if (item.gameId ~= nil) then --spell
            local player = PlayerList[item.sentBy] or {name="Me"}
            local spell_description = ""
            if (player ~= nil) then
                spell_description = spell_description .. "\nSent by: " .. player.name
            end
            local spell = SpellSprites[item.gameId]
            GuiImage(gui, next_id(), x +2, y +2,  spell.sprite, 1,1,1)--SpellSprites[item.gameId], 1)
            GuiTooltip(gui, spell.name, spell_description)
        elseif (item.stats ~= nil) then --wand
            GuiZSetForNextWidget(gui, 7)
            local wand = get_wand_sprite(item.stats.sprite)
            GuiImage(gui, next_id(), x + wand.ox, y + wand.oy, wand.sprite, 1, 1, 1)--, GUI_RECT_ANIMATION_PLAYBACK.PlayToEndAndPause)
            
            local left, right, hover = previous_data(gui)
            if (hover) then
                local player = PlayerList[item.sentBy] or {name="Me"}
                local nx, ny = (screen_width / 2) - 260, (screen_height/2) - 95
                local nox, nyx = 5, 0
                GuiZSetForNextWidget(gui, 6)
                GuiImageNinePiece(gui, next_id, nx, ny, 160, 160, 1)
                GuiZSetForNextWidget(gui, 5)
                GuiText(gui, nx + nox, ny + nyx, "Sent By " .. player.name)
                nyx = nyx + 15
                
                for key, value in ipairs(wand_tooltip(item.stats))do
                    GuiZSetForNextWidget(gui, 5)
                    GuiText(gui, nx + nox, ny + nyx, _wand_tooltip[key])
                    GuiZSetForNextWidget(gui, 5)
                    GuiText(gui, nx + 80, ny + nyx, tostring(value))
                    nyx = nyx + 10
                end
                nyx = nyx + 10
                local always_casts = item.alwaysCast or {}
                local deck = item.deck or {}
                if (#always_casts > 0) then
                    GuiZSetForNextWidget(gui, 5)
                    GuiText(gui, nx + 5, ny + nyx, "Always casts")
                    nox = 60
                    for index, value in ipairs(always_casts) do
                        GuiZSetForNextWidget(gui, 5)
                        GuiImage(gui, next_id(), nx + nox, ny + nyx, SpellSprites[value.gameId].sprite, 1, 0.8, 0.8)
                        nox = nox + 15
                    end
                    nox = 5
                    nyx = nyx + 15
                end
                for index, value in ipairs(deck) do
                    GuiZSetForNextWidget(gui, 5)
                    GuiImage(gui, next_id(), nx + nox, ny + nyx, SpellSprites[value.gameId].sprite, 1, 0.8, 0.8)
                    nox = nox + 15
                    if (index % 10 == 0) then
                        nyx = nyx + 20
                        nox = 5
                    end
                end
            end
            
        elseif (item.content ~= nil) then --flask
            local player = PlayerList[item.sentBy] or {name="Me"}
            local container_name = item.isChest and "Powder Pouch" or "Flask"
            if (player ~= nil) then
                container_name = container_name .. "\nSent by: " .. player.name
            end
            GuiZSetForNextWidget(gui, 7)
            if (item.isChest) then
                GuiImage(gui, next_id(), x + 2, y + 2, "data/ui_gfx/items/material_pouch.png", 1, 1, 1)
            else
                GuiColorSetForNextWidget(gui, item.color.r, item.color.g, item.color.b, 1)
                GuiImage(gui, next_id(), x + 2, y + 2, "data/ui_gfx/items/potion.png", 1, 1, 1)
            end
            GuiTooltip(gui, container_name, flask_info(item.content, item.isChest))
        elseif (item.path ~= nil) then
            local player = PlayerList[item.sentBy] or {name="Me"}
            local item_name = nt_items[item.path] and nt_items[item.path].name or ""
            item_name = GameTextGetTranslatedOrNot(item_name)
            if (player ~= nil) then
                item_name = item_name .. "\nSent by: " .. player.name
            end
            local w, h = GuiGetImageDimensions(gui, item.sprite, 1)
            local ox = ((w - 20) / 2) * -1
            local oy = ((h - 20) / 2) * -1
            GuiZSetForNextWidget(gui, 7)
            GuiImage(gui, next_id(), x + ox, y + oy, item.sprite, 1, 1, 1)
            GuiTooltip(gui, item_name, "")
        end
    end

    local function draw_bank_item(x, y, i)
        local item_offset = i + bank_offset * 25
        local item = filteredItems[item_offset]
        if (item ~= nil) then
            draw_item_sprite(item, x, y)
        end

        GuiZSetForNextWidget(gui, 9)
        if (GuiImageButton(gui, next_id(), x, y, "", "data/ui_gfx/inventory/full_inventory_box.png")) then
            if (item ~= nil) then
                local wsQueue = json.decode(NT.wsQueue)
                local item = GetItemWithId(BankItems, item.id)
                RemoveItemWithId(wsQueue, item.id)
                RemoveItemWithId(BankItems, item.id)
                --GamePrint("Stay on the left wing altar in the holy mountain to receive your item.")
                local queue = json.decode(NT.queuedItems)
                table.insert(queue, item)
                NT.wsQueue = json.encode(wsQueue)
                NT.queuedItems = json.encode(queue)
            end
        end
    end

    local function filterItems()
        local filterkey = bankfilter
        if (filterkey == "") then
            filteredItems = BankItems
            return
        end
        local ret = {}

        for _, item in ipairs(BankItems) do
            if (item.gameId ~= nil) then -- spell
                local spell = SpellSprites[item.gameId]
                if (string.find(string.lower(spell.name), string.lower(filterkey))) then
                    table.insert(ret, item)
                end
            elseif (item.stats ~= nil) then -- wand
                local found = false
                for _, action in ipairs(item.alwaysCast or {}) do
                    local spell = SpellSprites[action.gameId]
                    if (spell ~= nil) then
                        if (string.find(string.lower(spell.name), string.lower(filterkey))) then
                            found = true
                        end
                    end
                end
                for _, action in ipairs(item.deck or {}) do
                    local spell = SpellSprites[action.gameId]
                    if (spell ~= nil) then
                        if (string.find(string.lower(spell.name), string.lower(filterkey))) then
                            found = true
                        end
                    end
                end

                if (found) then
                    table.insert(ret, item)
                end
            elseif (item.content ~= nil) then -- flask
                local container = item.isChest and "Powder Stash\n" or "Flask\n"
                container = container .. flask_info(item.content, item.isChest)
                if (string.find(string.lower(container), string.lower(filterkey))) then
                    table.insert(ret, item)
                end
            elseif (item.path ~= nil) then -- entity item
                local item_name = nt_items[item.path] and nt_items[item.path].name or ""
                item_name = GameTextGetTranslatedOrNot(item_name)
                if (string.find(string.lower(item_name), string.lower(filterkey))) then
                    table.insert(ret, item)
                end
            end
        end

        filteredItems = ret
    end

    local function sortItems()
        table.sort(BankItems, function (a, b)
            if (a.gameId) then
                if (b.gameId) then return a.gameId < b.gameId end
                if (b.stats) then return false end
                if (b.content) then return true end
                if (b.path) then return true end
            elseif (a.stats) then
                if (b.gameId) then return true end
                if (b.stats) then return a.stats.sprite < b.stats.sprite end
                if (b.content) then return true end
                if (b.path) then return true end
            elseif (a.content) then
                if (b.gameId) then return false end
                if (b.stats) then return false end
                if (b.content) then return false end
                if (b.path) then return true end
            elseif (a.path) then
                return false
            end
            return false
        end)
    end

    local function draw_item_bank()
        local pos_x, pos_y = (screen_width / 2) - 90, (screen_height/2) - 90
        local offx, offy = 20, 20
        GuiOptionsAdd(gui, GUI_OPTION.NoPositionTween)
        GuiZSetForNextWidget(gui, 10)
        GuiImageNinePiece(gui, next_id(), pos_x, pos_y, 160, 170, 1, "mods/Advanced Inventory/files/ui/background.png")
        GuiZSetForNextWidget(gui, 9)
        if (GuiImageButton(gui, next_id(), pos_x + 147, pos_y, "", "mods/Advanced Inventory/files/ui/close.png")) then
            show_bank = not show_bank
        end
        GuiZSetForNextWidget(gui, 9)
        if (GuiImageButton(gui, next_id(), pos_x + 10, pos_y, "", "mods/Advanced Inventory/files/ui/sort.png")) then
            sortItems()
        end
        GuiZSetForNextWidget(gui, 9)
        bankfilter = GuiTextInput(gui, next_id(), pos_x + 30, pos_y, bankfilter, 100, 32)
        filterItems()
        local pages = math.floor(#filteredItems / 25)
        if (bank_offset > pages) then bank_offset = pages end
        for i = 1, 25 do
            draw_bank_item(pos_x + offx,pos_y + offy, i)
            
            offx = offx + 25

            if (i % 5 == 0) then
                offx = 20
                offy = offy + 25
            end
        end        
        offy = offy + 5
        if (GuiImageButton(gui, next_id(), pos_x, pos_y + offy, "", "mods/Advanced Inventory/files/ui/prev_page.png")) then
            change_bank_offset(-1, pages)
        end
        GuiText(gui, pos_x + 75, pos_y + offy + 5, tostring(bank_offset+1) .. "/" .. tostring(pages+1))
        if GuiImageButton(gui, next_id(), pos_x + 140, pos_y + offy, "", "mods/Advanced Inventory/files/ui/next_page.png")then
            change_bank_offset(1, pages)
        end
        GuiOptionsClear(gui)
    end

    function draw_gui()
        --local frame = GameGetFrameNum()
        reset_id()
        GuiStartFrame(gui)
        GuiIdPushString( gui, "ntbank")

        -- controller stuff
        local player = GetPlayer()
        if (player) then
            local platform_shooter_player = EntityGetFirstComponentIncludingDisabled(player, "PlatformShooterPlayerComponent")
            if (platform_shooter_player) then
                local is_gamepad = ComponentGetValue2(platform_shooter_player, "mHasGamepadControlsPrev")
                if (is_gamepad) then
                    GuiOptionsAdd(gui, GUI_OPTION.NonInteractive)
                    GuiOptionsAdd(gui, GUI_OPTION.AlwaysClickable)
                end
            end
            --close on inventory change
            local inven_gui = EntityGetFirstComponent(player, "InventoryGuiComponent")
            if (inven_gui ~= nil) then
                local is_open = ComponentGetValue2(inven_gui, "mActive")

                if (is_open and not last_inven_is_open) then
                    show_bank = false
                end
                last_inven_is_open = is_open
            end
        end
        -- close on escape (pause)
        if (show_bank and GamePaused) then
            show_bank = false
        end

        if (GuiImageButton(gui, next_id(), 160, 0, "", "mods/Advanced Inventory/files/ui/buttons/bank.png")) then
            show_bank = not show_bank
        end
        GuiTooltip(gui, "Advanced Inventory", "")

        if (show_bank) then
            draw_item_bank()
        end

        GuiIdPop(gui)
    end
end

draw_gui()