dofile_once("mods/Advanced Inventory/files/scripts/item_list.lua")
dofile_once("data/scripts/lib/utilities.lua")

dofile_once("mods/Advanced Inventory/files/store.lua")
dofile_once("mods/Advanced Inventory/files/scripts/json.lua")

dofile_once("mods/Advanced Inventory/files/scripts/utils.lua")
dofile_once("data/scripts/gun/procedural/gun_procedural.lua")
dofile_once("data/scripts/gun/procedural/gun_action_utils.lua")

--local entity_id = GetUpdatedEntityID()

function Eat()
    local players = EntityGetWithTag("player_unit")
    local x, y = EntityGetTransform(players[1])

    --local x, y = EntityGetTransform(entity_id)

    -- tags -> card_actions | tablet | wand | item_physics
    local card_actions = EntityGetWithTag("card_action")
    local wands = EntityGetWithTag("wand")
    local flasks = EntityGetWithTag("item_physics")

    if (#card_actions > 0) then
        local msg = {}
        local send = false
        for _, spell_id in ipairs(card_actions) do
            local in_world = false
            local components = EntityGetComponent(spell_id, "SimplePhysicsComponent")
            if (components ~= nil) then
                in_world = true
            end
            local tx, ty = EntityGetTransform(spell_id)

            
            if (in_world) then
                local distance = math.abs(x - tx) + math.abs(y - ty)
                if (distance < 100) then
                --    GamePrint(EntityGetTags(spell_id))
                --    GamePrint(spell_id)
                --    GamePrint(distance)
                end

                if (distance < 5 and EntityGetComponent(spell_id, "ItemCostComponent") == nil) then
                    local item = EntityGetFirstComponent(spell_id, "ItemComponent")
                    local item_component = EntityGetFirstComponent(spell_id, "ItemActionComponent")
                    local uses_remaining = ComponentGetValue2(item, "uses_remaining")
                    local action_id = ComponentGetValue2(item_component, "action_id")
                    NT.lastId = NT.lastId + 1
                    local newId = "b" .. tostring(NT.lastId)
                    table.insert(msg, {id=newId, gameId=action_id, usesRemaining=uses_remaining})
                    send = true
                    EntityLoad("data/entities/particles/poof_pink.xml", tx, ty)
                    EntityKill(spell_id)
                end
            end
            
            
        end

        if (send) then
            NT.refresh = true
            local queue = json.decode(NT.wsQueue)
            table.insert(queue, msg[1])
            NT.wsQueue = json.encode(queue)
        end
    end

    if (#wands > 0) then
        local msg = {}
        local send = false
        for _, wand_id in ipairs(wands) do
            local wand = nil
            local wand_sprite = nil
            local item_comp = nil
            local in_world = false
            local components = EntityGetComponent(wand_id, "SimplePhysicsComponent")
            if (components ~= nil) then
                in_world = true
            end

            tx, ty = EntityGetTransform(wand_id)
            if (in_world and wand == nil) then
                local distance = math.abs(x - tx) + math.abs(y - ty)
                if (distance < 5) then
                    wand = wand_id
                    local ability_comp = EntityGetFirstComponentIncludingDisabled(wand_id, "AbilityComponent")
                    item_comp = EntityGetFirstComponentIncludingDisabled(wand_id, "ItemComponent")
                    wand_sprite = ComponentGetValue2(item_comp, "ui_sprite")
                    if (wand_sprite ~= nil and #wand_sprite == 0) then
                        wand_sprite = ComponentGetValue2(ability_comp, "sprite_file")
                    end
                end
            end

            if wand ~= nil then
                local serialized = {}
                
                local ability_comp = EntityGetFirstComponentIncludingDisabled(wand, "AbilityComponent")
                local sprite_comp = EntityGetFirstComponentIncludingDisabled(wand, "SpriteComponent")
                local hotspot_comp = EntityGetFirstComponentIncludingDisabled( wand, "HotspotComponent", "shoot_pos" )
                local named = ComponentGetValue2(item_comp, "always_use_item_name_in_ui")
                if (named) then
                    serialized.named = true
                    serialized.ui_name = ComponentGetValue2(item_comp, "item_name")
                else
                    serialized.named = false
                    serialized.ui_name = ""
                end
                serialized.sprite = wand_sprite
                
                serialized.mana_max = ComponentGetValue2(ability_comp, "mana_max")
                serialized.mana_charge_speed = ComponentGetValue2(ability_comp, "mana_charge_speed")
        
                serialized.reload_time = ComponentObjectGetValue2(ability_comp, "gun_config", "reload_time")
                serialized.actions_per_round = ComponentObjectGetValue2(ability_comp, "gun_config", "actions_per_round")
                serialized.deck_capacity = ComponentObjectGetValue2(ability_comp, "gun_config", "deck_capacity")
                serialized.shuffle_deck_when_empty = ComponentObjectGetValue2(ability_comp, "gun_config", "shuffle_deck_when_empty")
        
                serialized.spread_degrees = ComponentObjectGetValue2(ability_comp, "gunaction_config", "spread_degrees")
                serialized.speed_multiplier = ComponentObjectGetValue2(ability_comp, "gunaction_config", "speed_multiplier")
                serialized.fire_rate_wait = ComponentObjectGetValue2(ability_comp, "gunaction_config", "fire_rate_wait")
                serialized.gripX = ComponentGetValue2(sprite_comp, "offset_x")
                serialized.gripY = ComponentGetValue2(sprite_comp, "offset_y")
                serialized.tipX, serialized.tipY = ComponentGetValue2(hotspot_comp, "offset")
                local childs = EntityGetAllChildren(wand)
                local always_cast = {}
                local deck = {}
                if childs ~= nil then
                    for _, child in ipairs(childs) do
                        local item_comp = EntityGetFirstComponentIncludingDisabled(child, "ItemComponent")
                        local item_component = EntityGetFirstComponentIncludingDisabled(child, "ItemActionComponent")
                        local is_always_cast = ComponentGetValue2(item_comp, "permanently_attached")
                        local uses_remaining = ComponentGetValue2(item_comp, "uses_remaining")
                        local action_id = ComponentGetValue2(item_component, "action_id")
                        NT.lastId = NT.lastId + 1
                        local newId = "b" .. tostring(NT.lastId)
                        if (is_always_cast) then
                            table.insert(always_cast, {id= newId, gameId=action_id, usesRemaining=-1})
                        else
                            table.insert(deck, {id= newId,gameId=action_id, usesRemaining=uses_remaining})
                        end
                    end
                end
                NT.lastId = NT.lastId + 1
                local newId = "b" .. tostring(NT.lastId)
                table.insert(msg, {id = newId, stats = serialized, always_cast = always_cast, deck = deck})
                --print(json.encode(msg))
                send = true
                EntityLoad("data/entities/particles/poof_pink.xml", x, y)
                EntityKill(wand)
            end
        end

        if (send) then
            NT.refresh = true
            local queue = json.decode(NT.wsQueue)
            table.insert(queue, msg[1])
            NT.wsQueue = json.encode(queue)
        end
    end

    if (#flasks > 0) then
        local msg = {}
        local send = false
        local flask = nil
        local flask_inventory = nil
        for _, flask_id in ipairs(flasks) do
            local in_world = false
            local components = EntityGetComponent(flask_id, "PhysicsBodyComponent")
            local inventory = EntityGetFirstComponentIncludingDisabled(flask_id, "MaterialInventoryComponent")
            if (components ~= nil and inventory ~= nil) then
                in_world = true
            end

            tx, ty = EntityGetTransform(flask_id)
            if (in_world and flask == nil) then
                local distance = math.abs(x - tx) + math.abs(y - ty)
                if (distance < 5) then
                    flask = flask_id
                    flask_inventory = inventory
                end
            end
        end

        if flask ~= nil then
            local count_per_material_type = ComponentGetValue2(flask_inventory, "count_per_material_type")
            local item_comp = EntityGetFirstComponent(flask, "ItemComponent")
            local is_chest = ComponentGetValue2(item_comp, "item_name") == "$item_powder_stash_3"
            local serialized = {}
            local color = GameGetPotionColorUint(flask)
            serialized.color = {
                r = bit.band(bit.rshift(color, 0), 0xff) / 0xff,
                g = bit.band(bit.rshift(color, 8), 0xff) / 0xff,
                b = bit.band(bit.rshift(color, 16), 0xff) / 0xff
            }
            serialized.isChest = is_chest
            serialized.content = {}
            
            for k, v in pairs(count_per_material_type) do
                if v ~= 0 then
                    table.insert( serialized.content, {id = k-1, amount = v} )
                end
            end
            if (#serialized.content == 0) then
                table.insert(serialized.content, {id=0, amount=0})
            end
            NT.lastId = NT.lastId + 1
            local newId = "b" .. tostring(NT.lastId)
            serialized.id = newId
            table.insert(msg, serialized)
            send = true
            EntityLoad("data/entities/particles/poof_pink.xml", x, y)
            EntityKill(flask)
        end
        if (send) then
            NT.refresh = true
            local queue = json.decode(NT.wsQueue)
            table.insert(queue, msg[1])
            NT.wsQueue = json.encode(queue)
        end
    end

    if (#flasks > 0 ) then
        local msg = {}
        local items = {}
        local send = false
        for _, item_entity in ipairs(flasks) do
            local in_world = false
            local components = EntityGetComponent(item_entity, "PhysicsBodyComponent")
            local inventory = EntityGetFirstComponentIncludingDisabled(item_entity, "MaterialInventoryComponent")
            if (components ~= nil and inventory == nil) then
                in_world = true
            end

            tx, ty = EntityGetTransform(item_entity)
            if (in_world) then
                local distance = math.abs(x - tx) + math.abs(y - ty)
                if (distance < 5) then
                    table.insert(items, item_entity)
                end
            end
        end

        for _, item_entity in ipairs(items) do
            local path = EntityGetFilename(item_entity)
            local item_comp = EntityGetFirstComponentIncludingDisabled(item_entity, "ItemComponent")
            local sprite = ComponentGetValue2(item_comp, "ui_sprite")
            if (nt_items[path] ~= nil) then
                NT.lastId = NT.lastId + 1
                local newId = "b" .. tostring(NT.lastId)
                table.insert(msg, {id=newId, path=path, sprite=sprite})
                send = true
                EntityKill(item_entity)
            end
        end

        if (send) then
            NT.refresh = true
            EntityLoad("data/entities/particles/poof_pink.xml", x, y)
            local queue = json.decode(NT.wsQueue)
            table.insert(queue, msg[1])
            NT.wsQueue = json.encode(queue)
        end
    end
end

function Spitt()
    local players = EntityGetWithTag("player_unit")
    local x, y = EntityGetTransform(players[1])
    if (true) then
        local queue = json.decode(NT.queuedItems)
        if (#queue > 0) then
            for index, item in ipairs(queue) do
                if (item.gameId ~= nil) then --spell
                    SpawnSpell(item, x, y)
                elseif (item.stats ~= nil) then --wand
                    SpawnWand(item, x, y)
                elseif (item.content ~= nil) then
                    if (item.isChest) then
                        SpawnPowderStash(item.content, x, y)
                    else
                        SpawnFlask(item.content, x, y)
                    end
                elseif (item.path ~= nil) then
                    EntityLoad(item.path, x, y)
                end
            end
            NT.queuedItems = "[]"
            EntityLoad("data/entities/particles/poof_pink.xml", x, y)
        end
    end
end

function AddGunActionWithUses( entity_id, action_id, uses )
	if( action_id == "" ) then return 0 end
    local action_entity_id = CreateItemActionEntity( action_id )
    local item_comp = EntityGetFirstComponentIncludingDisabled(action_entity_id, "ItemComponent")
    if (item_comp ~= nil) then
        ComponentSetValue2(item_comp, "uses_remaining", uses)
    end
	if action_entity_id ~= 0 then
		EntityAddChild( entity_id, action_entity_id )
		EntitySetComponentsWithTagEnabled( action_entity_id, "enabled_in_world", false )
	end
end

function SpawnSpell(item, x, y)
    local action_entity_id = CreateItemActionEntity(item.gameId, x, y)
    local item_comp = EntityGetFirstComponentIncludingDisabled(action_entity_id, "ItemComponent")
    if (item_comp ~= nil) then
        ComponentSetValue2(item_comp, "uses_remaining", item.usesRemaining)
    end
    GamePickUpInventoryItem(GetPlayer(), action_entity_id, false)

end

function SpawnWand(wand, x, y)
    local force_unshuffle = GlobalsGetValue( "PERK_NO_MORE_SHUFFLE_WANDS", "0" ) == "1"
    local wand_entity = EntityLoad("mods/Advanced Inventory/files/entities/wand.xml")
    local ability_comp = EntityGetFirstComponentIncludingDisabled(wand_entity, "AbilityComponent")
    local item_comp = EntityGetFirstComponentIncludingDisabled(wand_entity, "ItemComponent")
    
    local always_casts = wand.always_cast or {}
    local deck = wand.deck or {}
    
    if (force_unshuffle) then
        wand.stats.shuffle_deck_when_empty = false
    end
    
    SetWandSprite(wand_entity, ability_comp, wand.stats.sprite, wand.stats.grip_x, wand.stats.grip_y, wand.stats.tip_x, wand.stats.tip_y)
    ComponentSetValue2(ability_comp, "ui_name", wand.stats.ui_name)
    if (wand.stats.named) then
        ComponentSetValue2(item_comp, "always_use_item_name_in_ui", true)
        ComponentSetValue2(item_comp, "item_name", wand.stats.ui_name)
    end
    ComponentObjectSetValue2(ability_comp, "gun_config", "reload_time", wand.stats.reload_time)
    ComponentObjectSetValue2(ability_comp, "gunaction_config", "fire_rate_wait", wand.stats.fire_rate_wait)
    ComponentSetValue2(ability_comp, "mana_charge_speed", wand.stats.mana_charge_speed)
    ComponentObjectSetValue2(ability_comp, "gun_config", "actions_per_round", wand.stats.actions_per_round)
    ComponentObjectSetValue2(ability_comp, "gun_config", "deck_capacity", wand.stats.deck_capacity)
    ComponentObjectSetValue2(ability_comp, "gun_config", "shuffle_deck_when_empty", wand.stats.shuffle_deck_when_empty)
    ComponentObjectSetValue2(ability_comp, "gunaction_config", "spread_degrees", wand.stats.spread_degrees)
    ComponentObjectSetValue2(ability_comp, "gunaction_config", "speed_multiplier", wand.stats.speed_multiplier)
    ComponentSetValue2(ability_comp, "mana_max", wand.stats.mana_max)
    ComponentSetValue2(ability_comp, "mana", wand.stats.mana_max)
    if (#always_casts > 0) then
        for _, spell in ipairs(always_casts) do
            AddGunActionPermanent(wand_entity, spell.gameId)
        end
    end

    if (#deck > 0) then
        for _, spell in ipairs(deck) do
            AddGunActionWithUses(wand_entity, spell.gameId, spell.usesRemaining)
        end
    end
    EntitySetTransform(wand_entity, x, y)
    GamePickUpInventoryItem(GetPlayer(), wand_entity, false)
end

function SpawnFlask(contents, x,y)
    local flask = EntityLoad("mods/Advanced Inventory/files/entities/empty_flask.xml", x, y)
    for i, inv in ipairs(contents) do
        AddMaterialInventoryMaterial(flask, CellFactory_GetName(inv.id), inv.amount)
    end
    GamePickUpInventoryItem(GetPlayer(), flask, false)
end

function SpawnPowderStash(contents, x,y)
    local flask = EntityLoad("mods/Advanced Inventory/files/entities/empty_powder_stash.xml", x, y)
    for i, inv in ipairs(contents) do
        AddMaterialInventoryMaterial(flask, CellFactory_GetName(inv.id), inv.amount)
    end
    GamePickUpInventoryItem(GetPlayer(), flask, false)
end